View Issue Details

IDProjectCategoryView StatusLast Update
0005730libmicrohttpdbuild systempublic2019-08-01 14:38
Reporterng0Assigned ToKarlson2k 
PrioritynormalSeverityminorReproducibilityhave not tried
Status closedResolutionfixed 
Product Version 
Target VersionFixed in Version0.9.64 
Summary0005730: build on freebsd 12 rel fails
DescriptionThere's 2 warnings and 1 error.
A couple of days ago this didn't happen.

For reference, this is with clang 6:
clang --version
FreeBSD clang version 6.0.1 (tags/RELEASE_601/final 335540) (based on LLVM 6.0.1)
Target: x86_64-unknown-freebsd12.0
Thread model: posix
InstalledDir: /usr/bin

build log:

/bin/sh ../../libtool --tag=CC --mode=compile cc -DHAVE_CONFIG_H -I. -I../.. -I../../src/include -I../../src/microhttpd -I/usr/local/include -I/usr/local/include/p11-kit-1 -DBUILDING_MHD_LIB=1 -fvisibility=hidden -pthread -I/usr/local/include -I/usr/local/include/p11-kit-1 -g -O2 -fno-strict-aliasing -MT libmicrohttpd_la-daemon.lo -MD -MP -MF .deps/libmicrohttpd_la-daemon.Tpo -c -o libmicrohttpd_la-daemon.lo `test -f 'daemon.c' || echo './'`daemon.c
libtool: compile: cc -DHAVE_CONFIG_H -I. -I../.. -I../../src/include -I../../src/microhttpd -I/usr/local/include -I/usr/local/include/p11-kit-1 -DBUILDING_MHD_LIB=1 -fvisibility=hidden -pthread -I/usr/local/include -I/usr/local/include/p11-kit-1 -g -O2 -fno-strict-aliasing -MT libmicrohttpd_la-daemon.lo -MD -MP -MF .deps/libmicrohttpd_la-daemon.Tpo -c daemon.c -fPIC -DPIC -o .libs/libmicrohttpd_la-daemon.o
daemon.c:4926:26: warning: result of comparison of constant 9223372036854775807
      with expression of type 'unsigned int' is always false
      [-Wtautological-constant-out-of-range-compare]
          if (TIME_T_MAX < uv) /* Compiler may warn on some platforms, i...
              ~~~~~~~~~~ ^ ~~
daemon.c:4987:45: warning: result of comparison of constant 36028797018963967
      with expression of type 'unsigned int' is always false
      [-Wtautological-constant-out-of-range-compare]
  ...(daemon->worker_pool_size >= (SIZE_MAX / sizeof (struct MHD_Daemon))) /...
      ~~~~~~~~~~~~~~~~~~~~~~~~ ^ ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
daemon.c:6088:16: error: no member named 'sin_len' in 'struct sockaddr_storage';
      did you mean 'ss_len'?
      bindaddr.sin_len = addrlen;
               ^~~~~~~
               ss_len
/usr/include/sys/_sockaddr_storage.h:49:16: note: 'ss_len' declared here
        unsigned char ss_len; /* address length */
                        ^
2 warnings and 1 error generated.
*** Error code 1

Stop.
make[3]: stopped in /usr/home/ng0/src/libmicrohttpd/src/microhttpd
*** Error code 1

Stop.
make[2]: stopped in /usr/home/ng0/src/libmicrohttpd/src
*** Error code 1

Stop.
make[1]: stopped in /usr/home/ng0/src/libmicrohttpd
*** Error code 1

Stop.
make: stopped in /usr/home/ng0/src/libmicrohttpd
TagsNo tags attached.

Activities

ng0

2019-05-22 14:34

reporter   ~0014431

What we have here is a difference between system implementations.

Debian, /usr/include/x86_64-linux-gnu/bits/socket.h

struct sockaddr_storage
  {
    __SOCKADDR_COMMON (ss_); /* Address family, etc. */
    char __ss_padding[_SS_PADSIZE];
    __ss_aligntype __ss_align; /* Force desired alignment. */
  };


FreeBSD, /usr/include/sys/_sockaddr_storage.h:

struct sockaddr_storage {
        unsigned char ss_len; /* address length */
        sa_family_t ss_family; /* address family */
        char __ss_pad1[_SS_PAD1SIZE];
        __int64_t __ss_align; /* force desired struct alignment */
        char __ss_pad2[_SS_PAD2SIZE];
};

ng0

2019-05-22 14:42

reporter   ~0014432

prior to this commit it works:
https://git.gnunet.org/libmicrohttpd.git/commit/?id=240604a333229d672f97682c4547cc67b5732bac

Karlson2k

2019-05-25 10:46

developer   ~0014439

Fixed by 2eb0a5f92d7496e36bbdcb7c1c8ba1d3a829ced0

Issue History

Date Modified Username Field Change
2019-05-22 14:20 ng0 New Issue
2019-05-22 14:34 ng0 Note Added: 0014431
2019-05-22 14:42 ng0 Note Added: 0014432
2019-05-25 10:46 Karlson2k Note Added: 0014439
2019-05-25 10:46 Karlson2k Assigned To => Karlson2k
2019-05-25 10:46 Karlson2k Status new => assigned
2019-05-25 10:47 Karlson2k Status assigned => resolved
2019-05-25 10:47 Karlson2k Resolution open => fixed
2019-05-25 10:47 Karlson2k Fixed in Version => 0.9.64
2019-08-01 14:38 Christian Grothoff Status resolved => closed